apiVersion: apps/v1
kind: Deployment 
metadata:
  name: hpa-nginx-deployment
spec:
  replicas: 4
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 25% # max number of new pods that can be created 
      maxUnavailable: 1 # max number of pods that can be unavailable
  selector:
    matchLabels:
      app: hpa-nginx
  template:
    metadata:
      labels:
        app: hpa-nginx
    spec:
      containers:
      - name: hpa-nginx
        image: nginx:latest
        resources:
           requests:
             cpu: 250m
             memory: "512Mi"
           limits:
             cpu: 500m # 0.5 core
             memory: "1Gi"
        ports:
        - containerPort: 80
# kubectl apply -f hpa-nginx-deployment.yaml